#
# spec file for package pure-ftpd (Version 1.0.32)
#
# Copyright (c) 2008 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild


Name:           pure-ftpd
BuildRequires:  mysql-devel openldap2-devel pam-devel postgresql-devel
Version:        1.0.32
Release:        141.1
Url:            http://www.pureftpd.org
Source:         ftp://ftp.pureftpd.org/pub/%{name}/releases/%{name}-%version.tar.bz2
Source1:        %{name}.init
Source2:        %{name}.pamd
Source3:        %{name}.xinetd
Source4:        %{name}.xml
Source5:        %{name}.firewall
Patch:          %{name}-1.0.20_config.patch
##Patch1:         %{name}-1.0.20_doc.patch
Patch2:         %{name}-1.0.20_virtualhosts.patch
Patch4:         %{name}-1.0.20_config_minuid.patch
##Patch5:         %{name}-1.0.20_ftpwho_path.patch
##Patch6:         pure-ftpd-1.0.21-ldap_schema.patch
Group:          Productivity/Networking/Ftp/Servers
License:        BSD 3-Clause
Provides:       ftp-server pureftpd
PreReq:         %insserv_prereq
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Summary:        A Lightweight, Fast, and Secure FTP Server
PreReq:         coreutils

%description
Pure-FTPd is a fast, production-quality, and standard-conforming FTP
server, based-on Troll-FTPd. Unlike other popular FTP servers, it has
no known security flaws, is trivial to set up, and is especially
designed for modern Linux kernels (setfsuid and sendfile capabilities)
. Features include: PAM support, IPv6, chroot()ed home directories,
virtual domains, built-in LS, anti-warez system, bandwidth throttling,
FXP, bounded ports for passive downloads, upload and download ratios,
Apache log files, and more.



%prep
%setup -q
%patch
%patch2
%patch4

%build
CFLAGS="%{optflags} -DLDAP_DEPRECATED -fstack-protector"
%configure \
	--sysconfdir=%{_sysconfdir}/%{name} \
	--with-ldap \
	--with-paranoidmsg \
	--with-altlog \
	--with-virtualhosts \
	--with-ftpwho \
	--with-mysql \
	--with-nonalnum \
	--with-pgsql \
	--with-cookie \
	--with-throttling \
	--with-ratios \
	--with-uploadscript \
	--with-diraliases \
	--with-pam \
	--with-puredb \
	--with-sysquotas \
	--with-quotas \
	--with-inetd \
	--with-tls \
	--with-boring \
	--with-largefile %_target_cpu-suse-linux
%{__make}
cat configuration-file/pure-config.pl |grep -v "^print" | grep -v "^exec" > configuration-file/pure-config-args
echo "print join(\" \", @flg);" >> configuration-file/pure-config-args

%install
%{__make} DESTDIR=%{buildroot} install
%{__install} -dD -m 0755 \
    %{buildroot}%{_sysconfdir}/{init.d,%{name},%{name}/vhosts,pam.d,xinetd.d,openldap/schema}
%{__install} -m 0755 \
        configuration-file/pure-config.pl \
        configuration-file/pure-config-args \
    %{buildroot}%{_sbindir}
%{__install} -m 0644 configuration-file/pure-ftpd.conf \
               %{buildroot}%{_sysconfdir}/%{name}
%{__install} -m 0755 %{S:1} %{buildroot}%{_sysconfdir}/init.d/%{name}
ln -sf /etc/init.d/%{name}  %{buildroot}%{_sbindir}/rc%{name}
%{__install} -m 0644 %{S:2}          %{buildroot}%{_sysconfdir}/pam.d/pure-ftpd
%{__install} -m 0644 %{S:3}          %{buildroot}%{_sysconfdir}/xinetd.d/pure-ftpd
%{__install} -m 0644 pureftpd.schema %{buildroot}%{_sysconfdir}/openldap/schema/
%{__install} -d						 %{buildroot}%{_datadir}/omc/svcinfo.d/
%{__install} -m 0644 %{S:4}			 %{buildroot}%{_datadir}/omc/svcinfo.d/
%{__install} -d						 %{buildroot}%{_sysconfdir}/sysconfig/SuSEfirewall2.d/services/
%{__install} -m 644 %{S:5}			 %{buildroot}%{_sysconfdir}/sysconfig/SuSEfirewall2.d/services/%name

%clean
%{__rm} -rf "%{buildroot}"

%preun
%stop_on_removal %{name}

%post
if [ -f etc/pure-ftpd.conf ]; then
        mv etc/pure-ftpd.conf etc/pure-ftpd/pure-ftpd.conf
fi

%postun
%insserv_cleanup
%restart_on_update %{name}

%files
%defattr(-, root, root)
%{_datadir}/omc/svcinfo.d/%name.xml
%doc AUTHORS CONTACT COPYING NEWS THANKS README README.Contrib
%doc README.Configuration-File HISTORY README.Virtual-Users
%doc README.LDAP pureftpd-ldap.conf README.MySQL README.PGSQL README.TLS
%{_mandir}/man8/*
%{_bindir}/*
%{_sbindir}/*
%dir %{_sysconfdir}/openldap
%dir %{_sysconfdir}/openldap/schema
%dir %{_sysconfdir}/%{name}
%dir %{_sysconfdir}/%{name}/vhosts
%config %{_sysconfdir}/openldap/schema/pureftpd.schema
%config %{_sysconfdir}/init.d/pure-ftpd
%config %{_sysconfdir}/pam.d/pure-ftpd
%config(noreplace) %{_sysconfdir}/%{name}/pure-ftpd.conf
%config(noreplace) %{_sysconfdir}/xinetd.d/pure-ftpd
%{_sysconfdir}/sysconfig/SuSEfirewall2.d/services/%name

%changelog
* Tue Apr  1 2008 mkoenig@suse.de
- remove dir /usr/share/omc/svcinfo.d as it is provided now
  by filesystem
* Thu Mar 20 2008 hvogel@suse.de
- Fix ldap schema [bnc:368864]
- add Short-Description to init script
* Tue Mar 27 2007 mskibbe@suse.de
- change path to firewall script (#247352)
* Fri Mar  2 2007 mskibbe@suse.de
- change path to firewall script (#247352)
* Wed Feb 28 2007 mskibbe@suse.de
- pure-ftpd - Support for FATE #300687: Ports for SuSEfirewall
  added via packages (#246931)
* Thu Jan 11 2007 mskibbe@suse.de
- change path to xml service document (fate #301713)
* Wed Dec  6 2006 mskibbe@suse.de
- add service xml document (fate #301713 )
* Wed Sep  6 2006 mskibbe@suse.de
- fix bug Bug 203798 - Restarting the ftp server using the
  "rcpure-ftpd stop/start" doesn't stop/kill the existing
  client-server instances
* Mon Sep  4 2006 kukuk@suse.de
- Add pam_loginuid.so to session management
* Thu Aug 31 2006 mskibbe@suse.de
- update to version 1.0.21 which
  o includes patch pure-ftpd-1.0.20-abort-transfer.patch
  o Rendezvous has been renamed Bonjour
  o The old PAM sample has been removed
  o -F option added to pure-pw
  o MAX_USER_LENGTH has been bumped to 127 due to popular demand
  o pam/* can now be used if security/* doesn't exist
  o simplify() simplifies paths ending by /. and /..
  o Experimental support for RFC2640 (UTF-8 filename encoding)
  o The LDAP schema has been changed: FTPStatus should be a boolean
  o OPTS MLST has been implemented
  o SITE UTIME has been implemented
  o TCP_CORK is on by default again. A new configure switch,
  - -without-cork, can disable it
  o Correctly format %%c and %%%% in fakesprintf()
  o The connection socket is now created with the Nagle algorithm
    disabled. It was the trick to dramatically improve performance
    when transfering a lot of small files
  o Use CLIENT_MULTI_STATEMENTS while connecting to a MySQL server
* Mon Aug 21 2006 kukuk@suse.de
- Reorder auth section of PAM config file to make sure all modules
  will always be evaluated.
* Mon Apr 10 2006 mrueckert@suse.de
- added pure-ftpd-1.0.20_config_minuid.patch:
  * configuration-file/pure-ftpd.conf.in: our ftp user has uid 40.
    if you want to map virtual users to this uid they would be
    blocked from login.
- added pure-ftpd-1.0.20_ftpwho_path.patch:
  * src/ftpwho-update.h: PAGE_SIZE is a function on
    glibc-2.4/kernel-2.6.16 on ppc64. use PATH_MAX for the filename
    member of the FTPWhoEntry_ struct
* Wed Jan 25 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Mon Jan 16 2006 hvogel@suse.de
- Patch from Patrick Gosling to handle transfer aborts during file
  upload correctly. [#133452]
* Fri Jan 13 2006 hvogel@suse.de
- Make use of Stack Protector
* Mon Oct 24 2005 mrueckert@suse.de
- cleaned up spec file
- add /etc/pure-ftpd/vhosts as base dir for virtual servers.
  (documentation and code changed accordingly.)
- fixed paths in the documenation
* Thu Oct 13 2005 hvogel@suse.de
- Build with DLDAP_DEPRECATED untill upstream applied one of the
  various ldap patches floating around on the sf.net project page
* Wed Aug 24 2005 hvogel@suse.de
- disable "funny" ftp messages to be a bit more professional
* Mon Nov  8 2004 kukuk@suse.de
- Use common-* PAM config files for pure-ftpd PAM configuration
* Thu Aug 12 2004 mmj@suse.de
- Use --with-diraliases
* Thu Aug 12 2004 mmj@suse.de
- Update to 1.0.20 which fixes compatibility issues.
* Wed Jun 23 2004 mmj@suse.de
- Update to 1.0.19 including:
  o Real disk space is no more shown.
  o A possible denial of service when too many users were connected
    should be fixed.
* Wed Mar  3 2004 mmj@suse.de
- Reflect in the configuration file that /etc/pure-ftpd/ now is a
  place to keep all the pure-ftpd configuration files.
* Tue Mar  2 2004 mmj@suse.de
- Move configuration file when updating
- Fix initscript to use /etc/pure-ftpd/pure-ftpd.conf [#35196]
- Update to 1.0.18 including:
  o UTF-8 characters are now supported in file names [#34829]
  o Buglets were fixed in the documentation.
  o Two new translations were added : hungarian and catalan
  o The server now uses distinct IPv4 and IPv6 to listen to both
    protocols on all operating systems. A new switch, -6, forces the
    server to only listen to IPv6.
  o W3C and CLF alternative log formats are now more standard
    conformant.
  o Pure-FTPd can now produce WU-FTPd (xferlog) compatible log files.
  o Support for Rendezvous was added on MacOS X.
  o Support for Apple / GNUStep plist data output was added to
    pure-ftpwho.
* Fri Feb 27 2004 mmj@suse.de
- Enable mysql and postgresql support, since they provide very
  good functionality with only tiny extra dependencies
- Compile with --with-nonalnum to support non alphanumeric chars
* Fri Jan 16 2004 kukuk@suse.de
- Add pam-devel to neededforbuild
* Thu Dec  4 2003 mmj@suse.de
- Update to pure-ftpd v. 1.0.17a
* Wed Oct 15 2003 mmj@suse.de
- Don't build as root
* Tue Aug 12 2003 mmj@suse.de
- Update to 1.0.16, with SSL/TLS support and many bugfixes
- Use new macros for stop/restart of services on rpm update/removal
* Sun Jul 27 2003 mmj@suse.de
- Support system quotas
* Tue Jun 17 2003 mmj@suse.de
- Update to version 1.0.15:
   A turkish translation has been added.
   Various functional and portability fixes have been made to the
  handling of upload scripts, to the pure-pw command and to the
  automatic creation of home directories.
   Accounts in a puredb database can now be quickly listed.
   The anonymous FTP directory can now be overriden on the Windows
  port (using a WIN32_ANON_DIR environment variable).
   The default banner has been stripped down to look more
  professionnal.
   Transfer speed on BSD systems has been improved.
   The license of the whole package has changed from GPL to a
  simplified BSD license.
* Thu May 15 2003 mmj@suse.de
- Allow dot-files in general, but prohibit writing of them [#26897]
* Wed Apr 30 2003 mmj@suse.de
- Apply the detach patch elsewhere to not break xinetd
- Add note to the xinetd conffile about the xinetd behaviour
- Rearrange the specfile a bit
* Thu Mar  6 2003 mmj@suse.de
- Fix the xinetd configuration file
* Fri Feb 28 2003 mmj@suse.de
- Add note to README.LDAP about use_ldap in the pam config
* Fri Jan 31 2003 mmj@suse.de
- Update to 1.0.14 and add a xinetd configuration file just in case
  the user wants to use it with xinetd. Default behaviour is still
  standalone.
* Mon Jan 20 2003 mmj@suse.de
- Added patch to detach from fd 0, 1 and 2 [#22836]
* Wed Nov 27 2002 mmj@suse.de
- Update to 1.0.13a which is a minor feature/bugfix-release
* Sat Oct  5 2002 ckm@suse.de
- Changed default config file to only allow ro anonymous logins,
  and tightened security in case writing is enabled.
* Sat Aug  3 2002 kukuk@suse.de
- Remove symlinks in postinstall script
- Add PreRequires for insserv
* Thu Jul  4 2002 kukuk@suse.de
- Update to version 1.0.12 (per-user limits)
* Fri Apr 26 2002 kukuk@suse.de
- Update to version 1.0.11 (minor bug fixes, better LDAP support)
* Mon Mar 11 2002 kukuk@suse.de
- Fix permissions
* Sat Feb 16 2002 kukuk@suse.de
- Fix print arguments [Bug #13389]
* Mon Feb 11 2002 ro@suse.de
- flgs in perl-config parser is an array
* Thu Jan 24 2002 kukuk@suse.de
- Update to version 1.0.8
- Compile with LDAP support
* Thu Nov 29 2001 kukuk@suse.de
- Add pam config file
- Cleanup example config file
* Thu Nov 22 2001 kukuk@suse.de
- Update to 1.0.3 (rename and quota fixes)
* Thu Nov  1 2001 kukuk@suse.de
- Initial release of a secure ftp server with LFS
